﻿using System;
using System.Drawing;
using System.Drawing.Drawing2D;

using DevExpress.XtraEditors;
using DevExpress.XtraTreeList;
using DevExpress.XtraTreeList.Columns;
using DevExpress.XtraTreeList.StyleFormatConditions;

namespace TestProject
{
    /// <summary>
    /// 메인 폼
    /// </summary>
    public partial class MainForm : XtraForm
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainForm()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainForm()
        {
            InitializeComponent();

            Load += Form_Load;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 폼 로드시 처리하기 - Form_Load(sender, e)

        /// <summary>
        /// 폼 로드시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void Form_Load(object sender, EventArgs e)
        {
            this.treeList.RowHeight                              = 25;
            this.treeList.OptionsView.AutoWidth                  = false;
            this.treeList.OptionsBehavior.ReadOnly               = true;
            this.treeList.OptionsBehavior.PopulateServiceColumns = true;
            this.treeList.KeyFieldName                           = "ID";
            this.treeList.ParentFieldName                        = "RegionID";

            this.treeList.DataSource = SalesData.GetSalesDataList();

            this.treeList.Columns[this.treeList.KeyFieldName   ].Visible = false;
            this.treeList.Columns[this.treeList.ParentFieldName].Visible = false;

            FormatConditionIconSetIcon formatConditionIconSetIcon1 = new FormatConditionIconSetIcon();

            formatConditionIconSetIcon1.PredefinedName  = "Rating4_1.png";
            formatConditionIconSetIcon1.ValueComparison = FormatConditionComparisonType.GreaterOrEqual;
            formatConditionIconSetIcon1.Value           = 75;

            FormatConditionIconSetIcon formatConditionIconSetIcon2 = new FormatConditionIconSetIcon();

            formatConditionIconSetIcon2.PredefinedName  = "Rating4_2.png";
            formatConditionIconSetIcon2.ValueComparison = FormatConditionComparisonType.GreaterOrEqual;
            formatConditionIconSetIcon2.Value           = 50;

            FormatConditionIconSetIcon formatConditionIconSetIcon3 = new FormatConditionIconSetIcon();

            formatConditionIconSetIcon3.PredefinedName  = "Rating4_3.png";
            formatConditionIconSetIcon3.ValueComparison = FormatConditionComparisonType.GreaterOrEqual;
            formatConditionIconSetIcon3.Value           = 25;

            FormatConditionIconSetIcon formatConditionIconSetIcon4 = new FormatConditionIconSetIcon();

            formatConditionIconSetIcon4.PredefinedName  = "Rating4_4.png";
            formatConditionIconSetIcon4.ValueComparison = FormatConditionComparisonType.GreaterOrEqual;
            formatConditionIconSetIcon4.Value           = 0;

            FormatConditionIconSet formatConditionIconSet = new FormatConditionIconSet();

            formatConditionIconSet.ValueType = FormatConditionValueType.Percent;

            formatConditionIconSet.Icons.Add(formatConditionIconSetIcon1);
            formatConditionIconSet.Icons.Add(formatConditionIconSetIcon2);
            formatConditionIconSet.Icons.Add(formatConditionIconSetIcon3);
            formatConditionIconSet.Icons.Add(formatConditionIconSetIcon4);

            FormatConditionRuleIconSet formatConditionRuleIconSet = new FormatConditionRuleIconSet();

            formatConditionRuleIconSet.IconSet = formatConditionIconSet;

            TreeListFormatRule treeListFormatRule = new TreeListFormatRule();

            treeListFormatRule.Rule   = formatConditionRuleIconSet;
            treeListFormatRule.Column = this.treeList.Columns["Sales"];

            this.treeList.FormatRules.Add(treeListFormatRule);

            this.treeList.BestFitColumns();
        }

        #endregion
    }
}